#!/usr/local/bin/perl
###################################################
$ver = "www.shurey.com (Dice Chat v1.1)";
###################################################
#

### 初期設定 ###
$log_file = './chat.log';
$user_file = './user.log';
$user_limit = 7; #日数
$cookie_name = 'd_chat';
$cookie_day = 30; #cookieの保存日数
$log_limit = 30; #ログファイルの保存日数（0=無期限）

# 下記サイトからの送信のみ受け付ける
$ref_site = 'http://www.shurey.com';

#ログ行数
$log_max = 1000;

#テストモード (ON=1/OFF=0)
$testmode = 0;

### 固定値 ###
$error = 0; #処理エラーコード
$error_message = ""; #エラーメッセージ
$e_time = 30; #連続書き込み制限の秒数
$d_time = 60; #削除可能経過時間の秒数
$r_time = 0; #書き込みの待機秒数
$dice = ""; #サイコロの表示
$status = ""; #更新されたステータス

#------------------------------------------------------

#リンク元の取得
$HTTP_REFERER = $ENV{'HTTP_REFERER'};
$HTTP_REFERER =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

#ホストの取得
$REMOTE_HOST = $ENV{'REMOTE_HOST'};
$REMOTE_ADDR = $ENV{'REMOTE_ADDR'};

#ホストのブラウザ情報を取得
$HTTP_USER_AGENT = $ENV{'HTTP_USER_AGENT'};
$HTTP_USER_AGENT =~ s/</&lt;/g;
$HTTP_USER_AGENT =~ s/>/&gt;/g;

#バッファ入力
	if ($ENV{'REQUEST_METHOD'} eq 'POST') {
		read(STDIN,$buffer,$ENV{'CONTENT_LENGTH'});
	} elsif ($ENV{'REQUEST_METHOD'} eq 'GET') {
		$buffer = $ENV{'QUERY_STRING'};
	}

#------------------------------------------------------

#CGI呼出元を取得
$SCRIPT_NAME = $ENV{'SCRIPT_NAME'};
#$SCRIPT_NAME = $ENV{'SCRIPT_FILENAME'};

#ハッシュへの振り分け
if (index($buffer,"&") > 0) {
	@lines = split(/&/,$buffer);
	foreach (@lines) {
		if (index($_,"=") > 0) {
			($a,$b) = split(/=/,$_);
			#デコード
			$b =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
			#受信データの禁則処理
			#$b =~ s/&/&amp;/g;
			$b =~ s/</&lt;/g;
			$b =~ s/>/&gt;/g;
			$b =~ s/\+/" "/eg;
			#ハッシュ
			$get{$a} = $b;
		} else {
			$buffer = $_;
		}
	}
}

#改行コード
$get{'f_status'} =~ s/\r\n/<br>/g;
$get{'f_status'} =~ s/\r/<br>/g;
$get{'f_status'} =~ s/\n/<br>/g;

#改行コード
$get{'f_message'} =~ s/\r\n/<br>/g;
$get{'f_message'} =~ s/\r/<br>/g;
$get{'f_message'} =~ s/\n/<br>/g;

#日付の取得
$ontime = time;
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($ontime);
$year = $year + 1900;
$mon = sprintf("%02d",$mon+1);
$mday = sprintf("%02d",$mday);
$hour = sprintf("%02d",$hour);
$min = sprintf("%02d",$min);
$sec = sprintf("%02d",$sec);

#------------------------------------------------------

#USER file読込
&load_user;

#LOG file読込
&load_log;

### $get{'f_mode'};
### 0 = デフォルト
### 1 = リロード
### 2 = 投稿・ダイス
### 9 = 削除

if ($buffer eq '') {
	#cookie読込
	&load_cookie;
} elsif ($HTTP_REFERER =~ $ref_site) {
	if ($get{'f_mode'} == 2) { ###メッセージ書込またはダイス
		#送信
		#STATUS
		&check_user_status;
		#MESSAGE or DICE
		&check_log;
		if ($error == 0) {
			&write_user_status;
			if ($get{'f_dices'} > 0) {&throw_dice;}
			&write_message;
		}
	} elsif ($get{'f_mode'} == 9) {
		#メッセージ削除
		&delete_message;
	}
}

#ページの表示（リロード）
&index_view;

exit;

#------------------------------------------------------

### cookie読込 ###
sub load_cookie ($na, $nb) {
	foreach (split(/; /, $ENV{'HTTP_COOKIE'})) {
		($na, $nb) = split(/=/);
		if ($na eq $cookie_name) {
			#$nb =~ s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
			($get{'f_name'},$get{'f_status'}) = split(/\t/,$nb);
			last;
		}
	}
}

### cookieの準備 ###
sub set_cookie {
	$cookie_exp = gmtime($ontime + $cookie_day*24*60*60);
	$cookie_value = "$get{'f_name'}\t$get{'f_status'}";
	#$cookie_value =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
	$cookie_value = "$cookie_name=$cookie_value; path =./; expires=$cookie_exp;";
}

### ステータスの読み込み ###
sub load_user {
	if (-e $user_file) {
		open(LOG,$user_file);
		@lines_user = <LOG>;
		close(LOG);
	}
}

### ステータスの書き込み ###
sub write_user {
	my $line;
	my @new = "";
	my $num = 0;
	
	#ログの経過時間を確認
	if (-e $user_file) {
		foreach $line (@lines_user) {
			chomp($line);
			(@_) = split(/\t/,$line);
			#IP確認
			if ($_[2] eq $REMOTE_ADDR) {
				#同一IPがある場合
				if ($_[0] > $ontime - $e_time) {
					$error = 1;
					$r_time = $_[0] - ($ontime - $e_time);
				} else { 
					$num++;
				}
			} else {
				#同一IPがない場合
				push(@new,"$line\n");
			}
		}
	}

	if ($error < 1) {
		#入れ替え
		@lines_user = @new;
	
		#ユーザーの追加
		unshift(@lines_user,"$ontime\t$get{'f_name'}\t$REMOTE_ADDR\t$get{'f_status'}\n");
	
		#集計のログ書き出し
		if (open(LOG,"> $user_file")) {
			print LOG @lines_user;
			close(LOG);
			chmod 0666,$user_file;
		}
	}
}

### ステータスの確認 ###
sub check_user_status {
	my $line;
	my @new = "";
	
	#ログの経過時間を確認
	if (-e $user_file) {
		foreach $line (@lines_user) {
			chomp($line);
			(@_) = split(/\t/,$line);
			#ステータス表示の日数制限
			if (($log_limit > 0) && ($_[0] < $ontime - $log_limit*24*60*60)) {
				last;
			}
			#IPとステータスの確認
			if ($_[2] eq $REMOTE_ADDR) {
				#同一IPの場合
				#ステータス更新
				if ($_[4] ne $get{'f_status'}) {
					$status = "$get{'f_status'}";
				}
				#経過時間の確認
				if ($_[0] > $ontime - $e_time) {
					$error = 1;
					$r_time = $_[0] - ($ontime - $e_time);
					last;
				}
			} else {
				#同一IPでない場合更新リストに追加（変更なし）
				push(@new,"$line\n");
			}
		}
		#ユーザーログの入れ替え
		if ($error == 0) {@lines_user = @new;}
	}
}

### ステータスの書き込み(2) ###
sub write_user_status {
	#ユーザーの追加
	unshift(@lines_user,"$ontime\t$get{'f_name'}\t$REMOTE_ADDR\t$get{'f_status'}\n");

	#ログ数上限削除
	#if ($#lines_user > $log_max) {
	#	splice(@lines_user,$log_max + 1);
	#}

	#ステータスのログ書き出し
	if (open(LOG,"> $user_file")) {
		print LOG @lines_user;
		close(LOG);
		chmod 0666,$user_file;
	}
}

### ログ読み込み ###
sub load_log {
	@lines_log = "";

	#ログ読込
	if (-e "$log_file") {
		open(LOG,$log_file);
		@lines_log = <LOG>;
		close(LOG);
	}
}

### ログの連続書き込み確認 ###
sub check_log {
	my $line;

	if (-e $log_file) {
		foreach $line (@lines_log) {
			#chomp($line);
			(@_) = split(/\t/,$line);
			#IP確認
			if ($_[0] > $ontime - $e_time) {
				if ($_[2] eq $REMOTE_ADDR) {
					#同一IPがある場合
					$error = 2;
					$r_time = $_[0] - ($ontime - $e_time);
				}
			} else {
				last;
			}
		}
	}
}

### サイコロ ###
sub throw_dice {
	my ($count,$num);
	my $total = 0;

	#サイコロの個数
	if ($get{'f_dices'} > 1) {
		for ($count = 0; $count < $get{'f_dices'}; $count++){
			$num = int(rand($get{'f_side'})) + 1;
			#合計値
			$total = $total + $num;
			if ($count == 0) {
				$dice = $num;
			} else {
				$dice = "$dice,$num";
			}
		}
		#4要素あり（ダイス合計、ダイス各値、面数、個数）
		$dice = "$total\t$dice\t$get{'f_side'}\t$get{'f_dices'}";
	} else {
		$num = int(rand($get{'f_side'})) + 1;
		$dice = "$num\t-\t$get{'f_side'}\t1";
	}
}
	
### ログ書き込み ###
sub write_message {	
	#ログ追加（上に追加されるので表示とは逆順に追加）
	if ($get{'f_message'} ne "") {
		if ($get{'f_for'} eq "ALL") {
			unshift(@lines_log,"$get{'f_for'}\t$get{'f_message'}\n");
		} else {
			unshift(@lines_log,"DM\t$get{'f_for'}\t$get{'f_message'}\n");
		}
	}
	if ($dice ne "") {
		unshift(@lines_log,"DICE\t$dice\n");
	}
	if ($status ne "") {
		unshift(@lines_log,"STAT\t$get{'f_status'}\n");
	}
	unshift(@lines_log,"$ontime\t$get{'f_name'}\t$REMOTE_ADDR\n");
		
	#ログ数上限削除
	if ($#lines_log > $log_max) {
		splice(@lines_log,$log_max + 1);
	}

	#ログ書き出し
	if (open(LOG,"> $log_file")) {
		print LOG @lines_log;
		close(LOG);
		chmod 0666,$log_file;
	}
}

### ログ削除 ###
sub delete_message {
	my $count;

	for ($count = 0; $count < $#lines_log; $count++){
		#データ取り出し
		$line = $lines_log[$count];
		chomp($line);
		(@_) = split(/\t/,$line);
		#数字にマッチング
		if ($_[0] =~ /^\d+$/) {
			#IP確認
			if ($_[0] > ($ontime - $d_time)) {
				if (($_[0] eq $get{'f_memo'}) && ($_[2] eq $REMOTE_ADDR)) {
					#同一IPがある場合
					$lines_log[$count] = "$_[0]\t$_[1]\t$_[2]\tDEL\n";
					#ログ書き出し
					if (open(LOG,"> $log_file")) {
						print LOG @lines_log;
						close(LOG);
						chmod 0666,$log_file;
					}
					last;
				}
			} else {
				$error = 9;
				last;
			}
		}
	}
}

### 日時フォーマット ###

sub time_format {
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($_[0]);
	$year = $year + 1900;
	$mon = sprintf("%02d",$mon+1);
	$mday = sprintf("%02d",$mday);
	$hour = sprintf("%02d",$hour);
	$min = sprintf("%02d",$min);
	$sec = sprintf("%02d",$sec);
	"$year/$mon/$mday $hour:$min:$sec";
}

#------------------------------------------------------

### 画面表示 ###

sub index_view {
	#user_list
	$get{'f_status'} =~ s/<br>/\n/g;

	my $user_list = "<option value='ALL' selected>ALL</option>";
	
	my $set_for = "ALL"; #js
	
	#cookie
	&set_cookie;
	
	print <<"EOF";
Set-Cookie: $cookie_value;
Content-type: text/html

<!doctype html>
<html>
<head>
<meta charset="UTF-8">
<link href="d_chat.css" rel="stylesheet" type="text/css">
<title>Chat with Dice</title>
</head>
<body>
EOF

#エラー表示
	if ($error > 1) {
		print "<h3>ERROR</h3>\n";
		$set_for = "$get{'f_for'}";
	}
	
	if (($error == 1) || ($error == 2)) {
		print "<p></p>\n";
	}
	
	if ($error == 9) {
		print "<p>Can not delete your message. It is time over.</p>\n";
	}
	
	if ($error_message ne "") {
		print "<p>$error_message</p>\n";
	}

#ユーザー表示
	print "<h3>USER STATUS</h3>\n";
	$text = "";
	$num = 0;
	if (@lines_user ne '') {
		$text = "<div>";
		
		foreach $line (@lines_user) {
			chomp($line);
			if ($line ne '') {
				(@_) = split(/\t/,$line);
				#時間制限
				if ($_[0] > ($ontime - $user_limit*24*60*60)) {
					#セレクト
					if ($_[2] ne $REMOTE_ADDR) {
						$user_list = $user_list."<option value='$_[2]'>$_[1] ($_[2])</option>";
					}
					#時間
					$_[0] = &time_format($_[0]);
					#IPアドレス
					if ($_[2] eq $REMOTE_ADDR) {
						$_[2] = "<span class='fip2'>$_[2]</span>";
					}
					#ステータス行
					if ($_[3] eq "") {
						$_[3] = "<span class='fdelete'>[NO STATUS]</span>";
					}
					#ステータスボックス
					$text = $text."\n<div class='status_box'>\n<div><span class='fname'>$_[1]</span> <span class='fip'>($_[2])</span></div>\n<div class='fstatus'>$_[3]</div>\n<div class='ftime'>$_[0]</div>\n</div>";
					$num++;
				}
			}
		}
		$text = $text."\n</div>\n<div class='status_end'></div>";
	}
	#ユーザーなしの場合
	if ($num == 0) {$text = "<p class='nodata'>No user... (Time Limit $user_limit days)</p>";}
	#出力
	print "$text\n\n";
	
	my $value_message = "";
	if ($error > 0) {$value_message = "$get{'f_message'}";}
	
	print <<"EOF";

<h3>FORM</h3>

<form name="f_post" method="post" action="index.cgi">
	<input name="f_mode" type="hidden" value="0">
	<input name="f_ip" type="hidden" value="$REMOTE_ADDR">
	<input name="f_memo" type="hidden" value="">
<table border="0" cellpadding="2" cellspacing="2">
	<tr><td align="right">NAME:</td>
		<td colspan="2"><input name="f_name" type="text" size="30" maxlength="30" value="$get{'f_name'}" onKeyUp='inputForm(0)'> ($REMOTE_ADDR)</td>
	</tr>	
	<tr><td align="right">STATUS:</td>
		<td colspan="2"><input name="f_status" type="text" value="$get{'f_status'}" size="60" maxlength="100"></td>
	</tr>
	<tr><td align="right">DICE:</td>
		<td><select name="f_side">
			<option value="2">2</option>
			<option value="3">3</option>
			<option value="4">4</option>
			<option value="5">5</option>
			<option value="6" selected>6</option>
			<option value="10">10</option>
			<option value="12">12</option>
			<option value="15">15</option>
			<option value="18">18</option>
			<option value="20">20</option>
			<option value="100">100</option>
			</select> sided 
			<select name="f_dices" onChange='inputForm(2)'>
			<option value="0" selected>0</option>
			<option value="1">1</option>
			<option value="2">2</option>
			<option value="3">3</option>
			<option value="4">4</option>
			<option value="5">5</option>
			<option value="6">6</option>
			<option value="7">7</option>
			<option value="8">8</option>
			<option value="9">9</option>
			<option value="10">10</option>
			<option value="12">10</option>
			<option value="15">10</option>
			<option value="20">20</option>
			</select> dices</td>
		<td align="right"></td>
	</tr>
	<tr><td align="right">MESSAGE:</td>
		<td colspan="2"><textarea name="f_message" cols="50" rows="3" onKeyUp='inputForm(1)'>$value_message</textarea></td>
	</tr>
	<tr>
		<td align="right">FOR:</td>
		<td><select name="f_for">
				$user_list
			</select></td>
		<td align="right">SUBMIT: <input type="button" id="b_submit" onClick="set_mode()" value="Reload" disabled></td>
	</tr>
</table>
</form>

EOF

#テストモード
if ($testmode == 1) {
	if ($get{f_mode} == 9) {
		$del_timer = $ontime - $get{f_memo};
	} else {
		$del_timer = $ontime - $d_time;
	}
	$tmOff = "//";
	print <<"EOF";
	
<h3>TESTMODE</h3>
<pre>Cookie = $cookie_value</pre>
<pre>\$Buffer = $buffer</pre>
<pre>\$ontime = $ontime</pre>
<pre>\$d_time = $d_time ($del_timer)</pre>
<pre>\$get{'f_mode'} = $get{'f_mode'}</pre>
<pre>\$status = $status</pre>
<pre>\@lines_user = @lines_user</pre>
<pre>\@lines_log = @lines_log</pre>

EOF
} else {
	$tmOff = ""; #JavaScript
}

#ログ表示
	print "<h3>LOG</h3>\n";
	print "<p>[NOW : $year/$mon/$mday $hour:$min:$sec] <span id='update_field'></span></p>\n";
	
	my $count = 0;
	
	if (-e "$log_file") {
		my $text = "";
		#ログの書き込み時間@
		my $log_time = "";
		#ログのIPアドレス
		my $log_IP = "";
		#コメントブロック
		my $block1 = "";
		my $block2 = "";
		#削除ブロック
		my $del_mode = 0;
		$b_delete = "";
		#削除ボタンを表示した回数
		my $del_times = 0;
							
		#ログの最後を明示
		push(@lines_log, "EOF");
			
		foreach $line (@lines_log) {
			chomp($line);

			#行番号
			$count++;

			#コメント行と空行を飛ばす
			if (($line =~ m|^//|) || ($line eq '')) {
				#next;
			}
			
			(@_) = split(/\t/,$line);
			
			if ($_[0] eq "ALL") {
				#全ユーザー宛
				if ($del_mode > 0) {
					#削除されたログ
					$block2 = "$block2<div class='fdelete'>[Deleted Message]</div>\n";
				} else {
					$block2 = "$block2<div class='log_message'>$_[1]</div>\n";
					$del_mode = 2;
				}
			} elsif ($_[0] eq "DM")  {
				#DM（カレントユーザーが投稿者または受信者）
				my $f_user = &DM_user($_[1]);
				#カレントユーザーのIP（投稿者）
				my $f_IP = $_[1];
				if ($_[1] eq $REMOTE_ADDR) {
					$f_IP = "<span class='fip2'>$_[1]</span>";
				}
				$block2 = "$block2<div class='log_DM'>[DM &gt; $f_user <span class='fip'>($f_IP)</span>]</div>\n";
				if ($del_mode > 0) {
					#削除されたログ
					$block2 = "$block2<div class='fdelete'>[Deleted Message]</div>\n";
				} else {
					if (($_[1] eq $REMOTE_ADDR) || ($log_IP eq $REMOTE_ADDR)) {
						#カレントユーザーが投稿者または受信者の場合にメッセージを表示
						$block2 = "$block2<div class='log_message'>$_[2]</div>\n";
					} else {
						#メッセージを非表示
						$block2 = "$block2<div class='fdelete'>[Unreadable Message]</div>\n";
					}
					$del_mode = 2;
				}
			} elsif ($_[0] eq "STAT") {
				#ステータス更新
				$block2 = "$block2<div class='fstatus'>[STATUS &gt; $_[1]]</div>\n";
			} elsif ($_[0] eq "DICE") {
				#サイコロ
				$block2 = "$block2<div class='log_dice'><span class='fdice'>[DICE &gt; $_[1]]</span>";
				#diceの数
				if ($_[4] > 1) {
					$block2 = "$block2 <span class='fdelete'>$_[3] sided $_[4] dices ($_[2])</span>";
				} else {
					$block2 = "$block2 <span class='fdelete'>$_[3] sided dice</span>";
				}
				$block2 = "$block2</div>\n";
			} else {
				#日時、ユーザー名、IPアドレスの表示、DEL
				#ログブロックを書き出し
				if (($log_time ne $_[0]) && ($block2 ne "")) {
					if (($del_mode < 2) || ($del_times > 1)) {
						$b_delete = "";
					}
					$text = "$text<p class='log_block'>$block1$b_delete$block2</p>\n";
				}
				
				###新たなログブロック
				#初期値
				$del_mode = 0;
				$b_delete = "";

				if ($_[0] ne "EOF") {
					if ($_[0] < ($ontime - $log_limit*24*60*60)) {
						#ログ表示の中断
						#$_[0] = "EOF";
					}
				}

				if ($_[0] ne "EOF") {
					#ログの時間（次のログまで引き継ぐ）
					$log_time = "$_[0]";
					#IPアドレス更新
					$log_IP = "$_[2]";

					#時間
					my $f_time = &time_format($_[0]);
					#ログ表示の日数制限
					if (($log_limit > 0) && ($_[0] < ($ontime - $log_limit*24*60*60))) {
						last;
					}

					$block1 = "<div class='log_time'><span class='ftime'>$f_time</span> <span class='fname'>$_[1]</span> ";

					#カレントユーザーのIP（投稿者）
					if ($_[2] eq $REMOTE_ADDR) {
						$block1 = "$block1<span class='fip'>(<span class='fip2'>$_[2]</span>)</span>";
						#削除可能時間の確認、ボタンの表示は1回のみ
						if (($log_time > ($ontime - $d_time)) && ($del_times == 0)) {
							$b_delete = " <input type='button' id='b_delete' value='DELETE' onClick='del_line($log_time)'>";
						}
						$del_times++;
					} else {
						$block1 = "$block1<span class='fip'>($_[2])</span>";
					}
					#削除されたログ
					if ($_[3] eq "DEL") {
						$del_mode = 1;
					}
					$block2 = "</div>\n";
				}
			}
			
		}
		
		if ($text eq "") {$text = "<p class='nodata'>No log line...</p>";}
		
		print "$text\n";
	} else {
		print "<p class='nodata'>No log file...</p>\n";
	}
	
	if ($get{'f_side'} eq "") {
		$get{'f_side'} = 6;
	}
	
	print <<"EOF";

<h3>DOCUMENT</h3>

<ul>
<li>チャットログは自動的に更新されませんが、$e_time秒毎にログの更新をチェックしています。<br>
	更新したいときは、リロード（Reload Page）ボタンを押してください。
<li>名前（NAME）は必ず入力してください。
<li>ステータス（STATUS）はメッセージの書き込み時にユーザログとチャットログに記録されます。<br>
	ステータスのユーザーログはIPアドレス毎に管理し、同じIPアドレスからの書き込みがあると上書きします。<br>
	$user_limit日以内に書き込みあったユーザーのみ表示します。
<li>サイコロ（DICE）は面数（side）と個数を選びます。
<li>メッセージ（MESSAGE）とサイコロ（DICE）は同時に書き込むことが出来ます。これらはチャットログに表示されます。<br>
	メッセージは相手を指定することで、他の人には読めないDMとして送ることが出来ます。<br>
	メッセージのみ削除が可能です。削除は投稿時刻から$d_time秒以内に限り可能です。削除されたログは表示されませんが、ログファイル内には残っています。
<li>チャットログ及びステータスは$log_limit日以内のものだけ表示されます。<br>
	チャットログは$log_max行に制限されています。それを超えるログはログファイルから削除されます。<br>
	連続書き込みは$e_time秒で制限しています。<br>
	Cookieの保存期間は$cookie_day日です。
</ul>

<script language="javascript" type="text/javascript">
<!--
dice_side = $get{'f_side'};
if (isNaN($get{'f_side'}))  {dice_side = 6;}
document.f_post.f_side.value = dice_side;
document.f_post.f_for.value = "$set_for";

//ログファイルの更新時間を確認
n_mode = 0; //投稿時のフォームの設定値
count = 0; //カウントの初期値
ctext = ""; //カウント表示
rtime = $r_time; //残り時間タイマーの初期値
utext = "";

timerID = setInterval('check_timer()',1000); //1秒毎にチェック

function inputForm(num) {
	var s, s0, s1, s2;
	//基本モード設定
	n_mode = 1;
	s = "Reload";
	//NAME
	s0 = document.f_post.f_name.value;
	//DICE
	s2 = document.f_post.f_dices.value;
	if (s2 > 0) {
		n_mode = 2;
		s = "Throw Dices";
	}
	//MESSAGE
	s1 = document.f_post.f_message.value;
	if (s1 != "") {
		n_mode = 2;
		s = "Send Message";
	}
	
	if ((count >= $e_time) || (n_mode == 1)) {
		document.f_post.b_submit.disabled = false;
	}
	//if ((s0 != "") && ((s1 != "") || (s2 != ""))) {
		document.f_post.b_submit.value = s;
	//}
}

function check_timer() {
	//ctext = "";
	//連続書き込み禁止
	if (count == $e_time) {
		inputForm(0);
		//document.f_post.b_submit.disabled = false;
	}
	//デリートボタン削除
	if ((document.getElementById("b_delete")) && (count == $d_time)) {
		document.getElementById("b_delete").type = "hidden";
	}

	//エラーの残り時間を表示
	if (rtime > 0) {
		ctext = "[You can write after " + rtime + "s]";
		rtime--;
	}
	
	//ログチェック
	if ((count % $e_time) == 0) {
		getUpdate("$log_file");
	}
	
	if (count >= 0) {
		document.getElementById("update_field").innerHTML = ctext + " [" + count + "s elapsed]";
		//document.getElementById("update_field").innerHTML = ctext + " [wait " + rtime + "s]";
	} else {
		document.getElementById("update_field").innerHTML = ctext + " [stop timer]";
		clearInterval(timerID);
	}
	//カウントアップ
	count++;
}

//メッセージ確認
function set_mode() {
	if ((n_mode > 1) && (document.f_post.f_name.value == "")) {
		//名前が未入力の場合 
		alert("Don\'t write no name.");
	} else if ((n_mode == 2) && (document.f_post.f_message.value == "") && (document.f_post.f_dices.value == "0")) {
		//メッセージが未入力の場合
		alert("Don\'t write no message, no dice.");
	} else {
		//リロード(1)または送信(2)
		document.f_post.f_mode.value = n_mode;
		document.f_post.submit();
	}
}

//ログ削除
function del_line(num) {
	var bool = confirm("You want to delete this message . It\'s okay?");
	if (bool) {
		document.f_post.f_mode.value = 9;
		document.f_post.f_memo.value = num;
		document.f_post.submit();
	}
}

//ログファイルの更新時間を取得
function getUpdate(fileName) {
	var style_color;
	var obj = createRequest(); //リクエスト
	if (obj) {
		//通信実行
		obj.open("get",fileName);
		obj.onreadystatechange = function() {
			//通信完了
			if (obj.readyState == 4 && obj.status == 200) {
				//読込後の処理
				var date = new Date(obj.getResponseHeader("last-modified"));
				var g_time = (date.getTime() / 1000) - $ontime;
				//更新時間がNOWより後の場合
				if (g_time > 0) {
					style_color = "update_color";
				} else {
					style_color = "nocolor";
				}
				ctext = "(UPDATE : <span id='" + style_color + "'>" + date.getFullYear() + "/" + time_format(date.getMonth() + 1) + "/" + time_format(date.getDate()) + " " + time_format(date.getHours()) + ":" + time_format(date.getMinutes()) + ":" + time_format(date.getSeconds()) + "</span>)";
				//ctext = "(TEST : [" + count  + "] " + (date.getTime() / 1000) + " - " + $ontime + " = " + g_time;
			}
		}
		obj.send(null);ctext
	}
}

//非同期通信オブジェクトの生成
function createRequest() {
	try {
		return new XMLHttpRequest();
	} catch (e) {
		try {
			return new ActiveXObject("Microsoft.XMLHTTP");
		} catch (e) {
			return null;
		}
	}
	return null;
}

//数値を2桁表示
function time_format(num) {
	if (num < 10) {
	 	return "0" + num;
	} else {
	 	return num;
	}
}

//-->
</script>
<hr>
<div align="center"><a href="./">戻る</a></div>
</body>
<!--$ver-->
</html>
EOF
}

exit;

### IPアドレスからユーザー名を探す ###
sub DM_user {
	my $IP = $_[0]; #引数（IP）
	my $line;
	my $user = "";

	foreach $line (@lines_user) {
		(@_) = split(/\t/,$line);
		#IP確認
		if ($_[2] eq $IP) {
			#同一IPがある場合
			$user = $_[1];
			last;
		}
	}

	if ($user eq "") {
		return "<span class='fdelete'>unknown</span>";
	} else {
		return "<span class='fname'>$user</span>";
	}
}

